<template src="./template.html"></template>
<script lang="ts">
// import { getModule } from "nuxt-property-decorator";
import { Vue, Component, Prop } from "vue-property-decorator";
import { api, api_key_tiny_editor } from "~/common/constaint";
import { apiErrorHandler } from "~/utils/apiHanlers";
import { Watch } from "nuxt-property-decorator";
// import axios from "axios";
// import UserModule from "~/store/user";
// import { Store } from "vuex";
@Component({
  components: {
    MediaPicker: () => import("@/components/Seller/Store/Gallery/index.vue"),
  },
})
export default class SettingSellerOverViewStoreComponent extends Vue {
  tab = 0;
  api_key_tiny_editor = api_key_tiny_editor;
  tabVisible = false;
  resetContent = false;
  dialogMediaPicker = false;
  isShowUploadPhoto = true;

  get coverId() {
    return this.$store.state.adminCollection.coverId || "";
  }
  get imageUrl() {
    return this.$store.state.adminCollection.imageUrl || "";
  }
  get picture() {
    return this.$store.state.sellerStore.store?.picture || "";
  }
  set picture(val: any) {
    this.$store.commit("sellerStore/setStoreSetting", { picture: val });
  }

  get store() {
    return this.$store.state.sellerStore?.store;
  }

  get storeName() {
    return this.$store.state.sellerStore?.store?.store?.storeName || "";
  }
  set storeName(val: any) {
    this.$store.commit("sellerStore/setStoreStore", { storeName: val });
  }

  get isOnHomePage() {
    return this.$store.state.sellerStore?.store?.store?.isOnHomePage || "";
  }
  set isOnHomePage(val: any) {
    this.$store.commit("sellerStore/setStoreStore", { isOnHomePage: val });
  }

  get saveButton() {
    return this.$store.state.sellerStore?.store?.store?.saveButton || "";
  }
  set saveButton(val: any) {
    this.$store.commit("sellerStore/setStoreStore", { saveButton: val });
  }

  get colorVariant() {
    return (
      this.$store.state.sellerStore?.store?.store?.colorVariant || "#fb5607"
    );
  }
  set colorVariant(val: any) {
    this.$store.commit("sellerStore/setStoreStore", { colorVariant: val });
  }

  get productName() {
    return this.$store.state.sellerStore.store?.product?.productName || "";
  }
  set productName(val: any) {
    this.$store.commit("sellerStore/setStoreProduct", { productName: val });
  }

  get supportEmail() {
    return this.$store.state.sellerStore?.store?.store?.supportEmail || "";
  }
  set supportEmail(val: any) {
    this.$store.commit("sellerStore/setStoreStore", { supportEmail: val });
  }

  get announcement() {
    return this.$store.state.sellerStore?.store?.store?.announcement || "";
  }
  set announcement(val: any) {
    this.$store.commit("sellerStore/setStoreStore", { announcement: val });
  }
  get companyInfo() {
    return (
      this.$store.state.sellerStore?.store?.storeSetting?.companyInfo || ""
    );
  }
  set companyInfo(val: any) {
    this.$store.commit("sellerStore/setStoreSetting", { companyInfo: val });
  }

  get logo() {
    return this.$store.state.sellerStore?.store?.storeSetting?.logo || null;
  }
  set logo(val: any) {
    this.$store.commit("sellerStore/setStoreSetting", {
      logo: {
        id: val,
        imageUrl: this.imageUrl,
      },
    });
  }

  get subDomain() {
    return this.$store.state.sellerStore?.store?.store?.subDomain || "";
  }
  set subDomain(val: any) {
    this.$store.commit("sellerStore/setSubDomain", val);
  }
  get mainDomain() {
    return this.$store.state.sellerStore?.store?.store?.mainDomain || "";
  }
  set mainDomain(val: any) {
    this.$store.commit("sellerStore/setMainDomain", val);
  }

  get phoneNumber() {
    return (
      this.$store.state.sellerStore?.store?.storeSetting?.phoneNumber || ""
    );
  }
  set phoneNumber(val: any) {
    this.$store.commit("sellerStore/setStoreSetting", { phoneNumber: val });
  }

  convertImage(url: string) {
    return `${api}/${url}`;
  }
  onUploadImage() {
    //@ts-ignore
    this.$refs.fileImage.$refs.input.click();
  }

  isDomainExist = false;
  loadingCheckDomain = false;
  async onCheckDomain() {
    try {
      this.isDomainExist = false;
      if (!this.subDomain) return;
      this.loadingCheckDomain = true;
      await this.$api.store.sellerStoreCheckDomain({
        domain: this.subDomain + "." + this.mainDomain,
        storeId: this.storeId,
      });
    } catch (error) {
      this.isDomainExist = true;
      // apiErrorHandler(error, this);
    } finally {
      this.loadingCheckDomain = false;
    }
  }

  @Watch("dialogMediaPicker")
  async changeImage(val: boolean) {
    if (!val && this.coverId) {
      try {
        this.logo = this.coverId;
      } catch (error) {
        apiErrorHandler(error, this);
      }
    }
  }

  get initEditor() {
    return {
      height: 400,
      image_title: true,
      automatic_uploads: true,
      //@ts-ignore
      file_picker_callback: function (cb, value, meta) {
        var input = document.createElement("input");
        input.setAttribute("type", "file");
        input.setAttribute("accept", "image/*");
        input.onchange = function () {
          //@ts-ignore
          var file = this.files[0];

          var reader = new FileReader();
          reader.onload = function () {
            var id = "blobid" + new Date().getTime();
            var blobCache =
              //@ts-ignore
              tinymce.activeEditor.editorUpload.blobCache;
            //@ts-ignore
            var base64 = reader.result.split(",")[1];
            var blobInfo = blobCache.create(id, file, base64);
            blobCache.add(blobInfo);
            cb(blobInfo.blobUri(), { title: file.name });
          };
          reader.readAsDataURL(file);
        };

        input.click();
      },
      file_picker_types: "image",
      plugins: ["lists link image code help wordcount paste"],
      toolbar:
        "undo redo | formatselect | bold italic | forecolor alignleft aligncenter alignright alignjustify | bullist numlist outdent indent | image link media template codesample inserttable | charmap emoticons hr | pagebreak nonbreaking anchor toc | insertdatetime | help",
    };
  }
  get storeId() {
    return this.$store.state.sellerStore.storeId;
  }
}
</script>

<style lang="scss" scoped>
.domain-field {
  background: #ffffff;
  border: 1px solid #e5e7eb;
  border-radius: 6px;
  overflow: hidden;
  height: 40px;
  .sub-domain-field {
    background: 0;
    border: 0 !important;
    width: 100%;
    padding: 0 12px;
    font-family: "Inter";
    font-style: normal;
    font-weight: 400;
    font-size: 14px;
    line-height: 20px;
    outline: 0;
    color: #171717;
    &:focus {
      outline: 0;
    }
  }
  .main-domain-field {
    max-width: 175px;
    width: 100%;
    background: #e5e7eb;
    padding: 0 12px;
    display: flex;
    align-items: center;
  }
}
</style>
